function varargout = Vistree(varargin)
% VISTREE M-file for Vistree.fig
%      VISTREE, by itself, creates a new VISTREE or raises the existing
%      singleton*.
%
%      H = VISTREE returns the handle to a new VISTREE or the handle to
%      the existing singleton*.
%
%      VISTREE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in VISTREE.M with the given input arguments.
%
%      VISTREE('Property','Value',...) creates a new VISTREE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Vistree_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Vistree_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Vistree

% Last Modified by GUIDE v2.5 09-Oct-2006 18:50:52

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Vistree_OpeningFcn, ...
                   'gui_OutputFcn',  @Vistree_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Vistree is made visible.
function Vistree_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Vistree (see VARARGIN)

% Choose default command line output for Vistree
handles.output = hObject;
handles.loaded=0;
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Vistree wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Vistree_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in exitTag.
function exitTag_Callback(hObject, eventdata, handles)
% hObject    handle to exitTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
    ['Close ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)
% --- Executes on button press in exportTag.
function exportTag_Callback(hObject, eventdata, handles)
% hObject    handle to exportTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global selectedBranch;
if selectedBranch
    button = questdlg('Export data as A..','Secify Target','Variable','File','Cancel','Variable');
    if strcmp(button,'Variable')
        [elements, pVal] = retrieveExportedDate(selectedBranch);
        prompt = {'Branch Id:' ,'Elements:','P-Value:'};
        dlg_title = 'Specify Variables';
        num_lines = 1;
        def = {'branch','elements','pval'};
        answer = inputdlg(prompt,dlg_title,num_lines,def);
        if isempty(answer) == 0
            assignin('base',answer(1),selectedBranch);
            assignin('base',answer{2},elements);
            assignin('base',answer{3},pVal);
        end
    elseif strcmp(button,'File')
        [elements, pVal] = retrieveExportedDate(selectedBranch);
        [filename, pathname, filterindex] = uiputfile( ...
            {'*.txt','Text file (*.txt)';...
            '*.*',  'All Files (*.*)'}, ...
            'Save as');
        if isempty(filename) ==0
            branchStr = ['Branch ' num2str(selectedBranch)];
            elementsStr = ['Elements ' num2str(elements)];
            pValStr =['P-Value ' num2str(pVal)];
            fid = fopen(filename, 'wt');
            fprintf(fid, '%s\n%s\n\%s', branchStr,elementsStr,pValStr);
            fclose(fid)
        end
    end
else
    message = sprintf('No Branch was selected!\n, Please select a branch and then export');
    title = ['Bad Selection'];
    msgbox(message,title,'warn');
end

 
% --------------------------------------------------------------------
function [elements, pVal] = retrieveExportedDate(selectedBranch)
global hash;
elements= elementsBelow(hash(:,2) ,hash (:,1),selectedBranch);
ind = find(hash(:,1) == selectedBranch);
pVal = hash(ind,6);
% --------------------------------------------------------------------
function openTag_Callback(hObject, eventdata, handles)
% hObject    handle to openTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[file, dir, filterindex] = uigetfile({'*.mat', 'MATLAB data Files (*.mat)'}, 'Load Tree');
full_file = fullfile(dir,file);
if (filterindex~=0)
   load (full_file);
   %if check...
   handles.loaded=1;
   handles.parents = parents;
   handles.realClass=realClass;
   set(handles.loadedTag,'String',file );
   set(handles.loadedTag,'ForegroundColor',[0 0 0]);%black
       % saveas(handles.parallelCoordsTag,full_file);
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in buildTag.
function buildTag_Callback(hObject, eventdata, handles)
% hObject    handle to buildTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if    handles.loaded
    if    get(handles.blackTag,'Value')
        paintLevel =0;
    elseif get(handles.leavesTag,'Value')
        paintLevel =1;
    else
        paintLevel =2;
    end
    useFDR = get(handles.fdrTag,'Value');
    paintFactor = str2num(get(handles.paintFactorTag,'String'));
    [cscore,fscore,jscore] = buildTree(handles.parents,handles.realClass,paintLevel,paintFactor,useFDR,handles.axesTag);
    if  paintLevel ==2
         set(handles.scoreTag,'String',['Score = ', num2str(cscore)]);
         set(handles.JFScoresTag,'String',['J = ', num2str(jscore), ' F = ',num2str(fscore) ]);
    end
end
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function axesTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axesTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axesTag



% --- Executes on button press in fdrTag.
function fdrTag_Callback(hObject, eventdata, handles)
% hObject    handle to fdrTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of fdrTag




% --------------------------------------------------------------------
function fileMenuTag_Callback(hObject, eventdata, handles)
% hObject    handle to fileMenuTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function printTag_Callback(hObject, eventdata, handles)
% hObject    handle to printTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

printdlg(handles);
% --------------------------------------------------------------------
function saveAsTag_Callback(hObject, eventdata, handles)
% hObject    handle to saveAsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[file, dir, filterindex] = uiputfile( ...
    {'*.fig', 'MATLAB figure Files (*.fig)';'*.bmp','Bitmap files (*.bmp)'; '*.eps','EPS Level 1 (*.eps)'; '*.*',  'All Files (*.*)'}, ...
    'Save as');
full_file = fullfile(dir,file);
if (filterindex~=0)
    saveas(handles.axesTag,full_file);
end




function paintFactorTag_Callback(hObject, eventdata, handles)
% hObject    handle to paintFactorTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of paintFactorTag as text
%        str2double(get(hObject,'String')) returns contents of paintFactorTag as a double




% --------------------------------------------------------------------
function aboutTag_Callback(hObject, eventdata, handles)
% hObject    handle to aboutTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
about;

% --------------------------------------------------------------------
function HelpTag_Callback(hObject, eventdata, handles)
% hObject    handle to HelpTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


