function varargout = aggClustOpt(varargin)
% AGGCLUSTOPT M-file for aggClustOpt.fig
%      AGGCLUSTOPT, by itself, creates a new AGGCLUSTOPT or raises the existing
%      singleton*.
%
%      H = AGGCLUSTOPT returns the handle to a new AGGCLUSTOPT or the handle to
%      the existing singleton*.
%
%      AGGCLUSTOPT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in AGGCLUSTOPT.M with the given input arguments.
%
%      AGGCLUSTOPT('Property','Value',...) creates a new AGGCLUSTOPT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before aggClustOpt_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to aggClustOpt_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help aggClustOpt

% Last Modified by GUIDE v2.5 18-Oct-2006 12:12:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @aggClustOpt_OpeningFcn, ...
                   'gui_OutputFcn',  @aggClustOpt_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before aggClustOpt is made visible.
function aggClustOpt_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to aggClustOpt (see VARARGIN)

% Choose default command line output for aggClustOpt
handles.output = hObject;
handles.mode = 0;
handles.dataRepresentation=0;% distance= 0,  similarity= 1, raw = 2;
% Update handles structure
guidata(hObject, handles);

% Make the GUI modal
set(handles.figure1,'WindowStyle','modal')

% UIWAIT makes numOfClassesDlg wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = aggClustOpt_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure

DISTANCE_MEASURES = {   ...
    'euclidean'     ,   ...
    'seuclidean'    ,   ...
    'cityblock'     ,   ...
    'mahalanobis'   ,   ...
    'minkowski'     ,   ...
    'cosine'        ,   ...
    'correlation'   ,   ...
    'hamming'       ,   ...
    'jaccard'       ,   ...
    'chebychev'
    };

LINKAGE_TYPES = {       ...
    'single'        ,   ...
    'complete'      ,   ...
    'average'       ,   ...
    'weighted'      ,   ...
    'centroid'      ,   ...
    'median'        ,   ...
    'ward'
};
    
varargout{1} = handles.mode;
varargout{2} = DISTANCE_MEASURES{get(handles.distanceLB, 'Value')};
varargout{3} = LINKAGE_TYPES{get(handles.linkageLB, 'Value')};
if get(handles.distancesTab,'Value')
    state =0;
elseif get(handles.similaritiesTab,'Value')
    state =1;
else
     state =2;
end
varargout{4} = state;
delete(handles.figure1);


% --- Executes on button press in cancelButton.
function cancelButton_Callback(hObject, eventdata, handles)
% hObject    handle to cancelButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Just close the figure, the default mode is anyway zero (to support other
% ways of closing the dialog
uiresume(handles.figure1);


% --- Executes on button press in runBotton.
function runBotton_Callback(hObject, eventdata, handles)
% hObject    handle to runBotton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.mode = 1;
guidata(hObject, handles);
uiresume(handles.figure1);


% --- Executes on selection change in distanceLB.
function distanceLB_Callback(hObject, eventdata, handles)
% hObject    handle to distanceLB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns distanceLB contents as cell array
%        contents{get(hObject,'Value')} returns selected item from distanceLB


% --- Executes during object creation, after setting all properties.
function distanceLB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to distanceLB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in linkageLB.
function linkageLB_Callback(hObject, eventdata, handles)
% hObject    handle to linkageLB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns linkageLB contents as cell array
%        contents{get(hObject,'Value')} returns selected item from linkageLB


% --- Executes during object creation, after setting all properties.
function linkageLB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to linkageLB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



%
% --- Executes on button press in rawTag.
function rawTag_Callback(hObject, eventdata, handles)
% hObject    handle to rawTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of rawTag
state = get(hObject,'Value');
set (handles.distanceLB,'Enable','on');
guidata(hObject, handles);



% --- Executes on button press in similaritiesTab.
function similaritiesTab_Callback(hObject, eventdata, handles)
% hObject    handle to similaritiesTab (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of similaritiesTab
state = get(hObject,'Value');
set (handles.distanceLB,'Enable','inactive');
guidata(hObject, handles);


% --- Executes on button press in distancesTab.
function distancesTab_Callback(hObject, eventdata, handles)
% hObject    handle to distancesTab (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of distancesTab
state = get(hObject,'Value');
set (handles.distanceLB,'Enable','inactive');
guidata(hObject, handles);

