
%function [classesMatrix]=create2ClassesFromFamilyTreeBranches(familyTree)
%create2ClassesFromFamilyTreeBranches
%Input - 
% familyTree - a [branches X 3] structure - 
%       familyTree{ind,1}  - current branch
%       familyTree{ind,2}  - left (samll potential)  branch
%       familyTree{ind,3}  - right (high potential)  branch
% Output-
% classesMatrix  - a [x-1,x+1] matrix: 
%       x-1 all the branches except of the root
%       x+1 all the leaves (elements)
%    where classesMatrix(ind,:) is a vector size of the number of the
%    elements and '1' denotes elements that aren't in the group and '2'
%    elements that are.
function [classesMatrix]=create2ClassesFromFamilyTreeBranches(familyTree)
[x,y] =size(familyTree);
classesMatrix = ones(x-1,x+1);% x - number of branches, x+1 - sumber of leaves (since it is a binary tree)
for ind =2: x %starting from the second
    currentGroupAsStr = familyTree{ind,1};
    currentGroup=str2num(currentGroupAsStr);
    classesMatrix(ind-1,currentGroup)=2;
end