%function [newPVals]= fdrCorrection(oldPVals,type)
% See 
% %`  www.sph.umich.edu/~nichols/FDR/ENAR2002.ppt
% % www.math.tau.ac.il/~ybenja/Temple.ppt
% Input -
% oldPVals - the single analysis PVals
% %  type (see www.math.tau.ac.il/~ybenja/Temple.ppt)
% %     1 if Independent / independent and continuous/ Positive dependent 
% %     2 if general 
% %   Output -
% nPVals - the corrected Pvals - by their original order 
function [newPVals]= fdrCorrection(oldPVals,type)
if nargin <2
    type = 1;
end
len = length(oldPVals);
[vals,inds] =sort(oldPVals);
if type ==1
    C = 1;
else
    C = log2(len);
end
newPVals = zeros(len,1);
for ind =1: len % run on the sorted vector
    correct = vals(ind) * C * len / ind ;
    newPVals(inds(ind)) = correct; % put in the old (original order)
end